# a3.py
# BEGIN REMOVE
# SOLUTIONS
# END REMOVE
# PUT YOUR NETID(S) HERE
# Sources/people consulted: FILL IN OR WRITE "NONE"
# PUT DATE YOU COMPLETED THIS HERE
# Skeleton by Prof. Lee, LJL2, Mar 9, 2022

"""See CS1110 Spring '22 A3 writeup."""

from freq import Freq


def percent_short(tokenlist, k):
    """Returns: percentage (as float between 0 and 100) of tokens in tokenlist
    that are of length <=k.

    Precondition: k [float] is >= 0. tokenlist is a non-empty list of strings.
    """
    pass # STUDENTS: your implementation must make effective use of for-loops.
         # You can only use lists (no dictionaries, for example)
    # BEGIN REMOVE
    short=0
    for t in tokenlist:
        if len(t) <=k:
            short+= 1
    return 100*short/len(tokenlist)
    # END REMOVE


def print_trend(results, labels):
    """
    Precondition:  `labels` is a list of strings where each string is a label for
    the corresponding entry in list `results` (which is a same-length list of
    numbers (floats or ints)).
    WARNING: it is possible for there to be repeated values in either `results`
    or `labels`.


    Prints info about `results` and `labels` in the following format (does
    not return anything)

    <label[0]>: <round(results[0], 2)>
    <label[1]>: <round(results[1], 2)>
    ... [etc.]

    The call round(x, 2) rounds to two decimal places.
    """
    pass
    # STUDENTS: implement this function, making effective use of for-loops.
    # BEGIN REMOVE
    for i in range(len(results)):
        print(labels[i]+": " + str(round(results[i],2)))
    # END REMOVE


def type_token_ratio(tokenlist):
    """Returns, as a float,

         100*(1 - (# of types in tokenlist/# of tokens in tokenlist))

    Precondition: tokenlist is a non-empty list of strings."""
    pass # STUDENTS: your implementation must make effective use of for-loops.
         # It must NOT use dictionaries.
    # BEGIN REMOVE
    types = []
    for t in tokenlist:
        if t not in types:
            types.append(t)
    return 100*(1 - len(types)/len(tokenlist))
    # END REMOVE


def percent_avg_or_shorter(tokenlist, tokenlistlist):
    """Returns: percentage (as float between 0 and 100) of tokens in tokenlist
    that are of length <=k, where k is the average token length across
    all the tokens in tokenlistlist.

    Example:
     if tokenlist were ["a", "b", "ccccc", "dd"]
     and tokenlistlist were
        [ ["abcd", "abcd", "abcd"],
          ["a", "b", "ccccc", "dd"],
          ["ef"]
        ]
     then k should be (3*4+2*1 +1*5 + 2*2)/8 = 2.875
     and this function should return 3/4 = 75.0 (UPDATE: not .75)

    Precondition: tokenlist is a non-empty list of strings.
    tokenlistlist is a non-empty list of non-empty lists of non-empty strings.
    tokenlist is in tokenlistlist
    """
    pass # STUDENTS: your implementation must make effective use of
         # a nested for-loop working on a nested list.
    # BEGIN REMOVE

    ## For grading: watch for "flattening" of a list, or not calling
    ## percent_short()

    # compute the average
    sum_of_lengths = 0
    num_tokens = 0
    for tlist in tokenlistlist:
        for t in tlist:
            sum_of_lengths += len(t)
            num_tokens+= 1
    k = sum_of_lengths/num_tokens

    return percent_short(tokenlist, k)

    # END REMOVE


def zipf(tokenlist, n):
    """Returns: percentage (as float between 0 and 100) of tokens in tokenlist
    that are of the top n most common types in tokenlist.

    Examples:
        zipf(["a", "a", "a", "a", "b",  "b",  "b", "c", "c", "d"], 1) --> 40
          because 4 of the 10 tokens are "a", the single most common type

        zipf(["a", "a", "a", "a", "b",  "b",  "b", "c", "c", "d"], 2) --> 70
         because the 2 most common types are "a" and "b", of which there are 7
         out of the 10 tokens in the input list

        zipf(["a", "a", "b", "b"], 1) --> 50
         It doesn't matter which of 'a' and 'b' are considered "the most common"
         here; 2 out of 4 list items = 50%.

    Precondition: n [int] is > 0, <= the number of distinct wordtypes in tokenlist
        tokenlist is a non-empty list of strings
    """
    pass    # STUDENTS: Provide a for-loop-based implementation.
            # You may NOT directly sort any dictionaries.
            # Instead, you MUST follow do the following steps.
            # 1. Iterate through tokenlist to build a dictionary where the
            #    keys are types and the values are the number of tokens of
            #    that type seen so far.
            # 2. Iterate through your dictionary to create a list of
            #    Freq objects, each corresponding to a key-value pair in
            #    your dictionary.
            # 3. Sort the list of Freq objects in reverse frequency order
            #    using <Freqlist>.sort(reverse=True)
            # 4. Use the sorted Freq-object list to compute the desired value:
            #    One quantity to compute is the sum of the frequencies of the
            #    first n Freqs in the Freq list.
            #


    # BEGIN REMOVE
    # Gather counts in a dictionary
    count_dict = {}
    for token in tokenlist:
        # Note: some students set `count_dict[token] = tokenlist.count(token)`.
        # This does mean count_dict[token] gets over-written with the same
        # value for each repetition of `token`.
        if token in count_dict:
            count_dict[token] += 1
        else:
            count_dict[token] = 1

    # Convert dictionary to sorted Freq list
    flist = []
    for wordtype in count_dict:
        flist.append(Freq(wordtype, count_dict[wordtype]))
    flist.sort(reverse=True)

    top_types = flist[:n]
    sum_top = 0
    for t in top_types:
        sum_top += t.freq

    assert sum_top <= len(tokenlist) # just in case something weird has happened
    return 100*sum_top/len(tokenlist)
    # END REMOVE
