# a3_test.py
# Prof. Lee, LJL2
# Mar 10, 2022



import cornellasserts as ca
import inspect  # to print the name of a (test) function that is running

import sample_lists as sl
import a3
# BEGIN REMOVE
from collections import Counter
# END REMOVE

# for testing output of a3.print_trend()
from contextlib import redirect_stdout
import io

# helper
def print_testing(start_or_end):
    """If start_or_end is 'start',
        print message about starting function that called this function
       If start_or_end is 'end'
        print message about ending function that called this function

    Precondition: start_or_end is either 'start' or 'end'"""
    caller = inspect.currentframe().f_back.f_code.co_name
    if start_or_end == 'start':
        print("Starting " + caller)
    elif start_or_end == 'end':
        print(caller + " seems to have passed (didn't crash/stop in the middle).")
        print("\n")


def test_percent_short():
    print_testing('start')

    # Testing no_repeats from sample_lists.py
    tlist = sl.no_repeats
    ca.assert_floats_equal(100.0, a3.percent_short(tlist,1))
    ca.assert_floats_equal(100.0, a3.percent_short(tlist,6))

    # Testing repeats from sample_lists.py
    tlist = sl.repeats
    ca.assert_floats_equal(0.0, a3.percent_short(tlist,1))
    ca.assert_floats_equal(89.28571428571429, a3.percent_short(tlist,6))
    ca.assert_floats_equal(100.0, a3.percent_short(tlist,11))

    # Testing wiki from sample_lists.py
    tlist = sl.wiki
    ca.assert_floats_equal(2.5, a3.percent_short(tlist,1))
    ca.assert_floats_equal(52.5, a3.percent_short(tlist,6))
    ca.assert_floats_equal(91.25, a3.percent_short(tlist,11))
    ca.assert_floats_equal(97.5, a3.percent_short(tlist,16))

    # Testing simplewiki from sample_lists.py
    tlist = sl.simplewiki
    ca.assert_floats_equal(3.75, a3.percent_short(tlist,1))
    ca.assert_floats_equal(75.0, a3.percent_short(tlist,6))
    ca.assert_floats_equal(98.75, a3.percent_short(tlist,11))
    ca.assert_floats_equal(100.0, a3.percent_short(tlist,16))

    # Testing dickens from sample_lists.py
    tlist = sl.dickens
    ca.assert_floats_equal(0.0, a3.percent_short(tlist,1))
    ca.assert_floats_equal(92.5, a3.percent_short(tlist,6))
    ca.assert_floats_equal(100.0, a3.percent_short(tlist,11))
    ca.assert_floats_equal(100.0, a3.percent_short(tlist,16))

    # Testing seuss from sample_lists.py
    tlist = sl.seuss
    ca.assert_floats_equal(5.0, a3.percent_short(tlist,1))
    ca.assert_floats_equal(97.5, a3.percent_short(tlist,6))
    ca.assert_floats_equal(100.0, a3.percent_short(tlist,11))
    ca.assert_floats_equal(100.0, a3.percent_short(tlist,16))

    # Testing stein from sample_lists.py
    tlist = sl.stein
    ca.assert_floats_equal(5.0, a3.percent_short(tlist,1))
    ca.assert_floats_equal(70.0, a3.percent_short(tlist,6))
    ca.assert_floats_equal(100.0, a3.percent_short(tlist,11))
    ca.assert_floats_equal(100.0, a3.percent_short(tlist,16))

    # Testing whitehead from sample_lists.py
    tlist = sl.whitehead
    ca.assert_floats_equal(8.75, a3.percent_short(tlist,1))
    ca.assert_floats_equal(85.0, a3.percent_short(tlist,6))
    ca.assert_floats_equal(97.5, a3.percent_short(tlist,11))
    ca.assert_floats_equal(98.75, a3.percent_short(tlist,16))

    print_testing('end')    


# helper function
def captured_from_print_trend(results, labels, get_return=False):
    helper = io.StringIO()
    with redirect_stdout(helper):
        returned = a3.print_trend(results, labels) 
    if get_return: 
        return returned
    else:  
        return helper.getvalue()

def test_print_trend():
    print_testing('start')
    
    # distinct labels and results
    results = [0.78999, 12]
    labels = ["yes", "no"]
    expected = 'yes: 0.79\nno: 12\n'
    out = captured_from_print_trend(results, labels)
    ca.assert_equals(expected, out)
    # make sure nothing was returned
    ca.assert_equals(None, captured_from_print_trend(results, labels, True))

    # repeated label
    results = [0.5, 12.3111]
    labels = ["good", "good"]
    expected = 'good: 0.5\ngood: 12.31\n'
    out = captured_from_print_trend(results, labels)
    ca.assert_equals(expected, out)
    # make sure nothing was returned
    ca.assert_equals(None, captured_from_print_trend(results, labels, True))
    
    # repeated result
    results = [13.13, 13.13]
    labels = ["1900", "2222"]
    expected = '1900: 13.13\n2222: 13.13\n'
    out = captured_from_print_trend(results, labels)
    ca.assert_equals(expected, out)
    # make sure nothing was returned
    ca.assert_equals(None, captured_from_print_trend(results, labels, True))

    # realistic results
    results = [0.0, 25.0, 75.0, 23.750000000000004, 26.249999999999996, 
               60.0, 50.0, 50.0, 27.500000000000004]
    labels = sl.sample_labels
    expected = ('no_repeats: 0.0\none_repeat: 25.0\nrepeats: 75.0\n' +
                'wiki: 23.75\nsimplewiki: 26.25\ndickens: 60.0\n' +
                'seuss: 50.0\nstein: 50.0\nwhitehead: 27.5\n')
    out = captured_from_print_trend(results, labels)
    ca.assert_equals(expected, out)
    # make sure nothing was returned
    ca.assert_equals(None, captured_from_print_trend(results, labels, True))

    print_testing('end')


def test_type_token_ratio():
    print_testing('start')

    # Testing no_repeats from sample_lists.py
    tlist = sl.no_repeats
    ca.assert_floats_equal(0.0, a3.type_token_ratio(tlist))

    # Testing one_repeat from sample_lists.py
    tlist = sl.one_repeat
    ca.assert_floats_equal(25.0, a3.type_token_ratio(tlist))

    # Testing repeats from sample_lists.py
    tlist = sl.repeats
    ca.assert_floats_equal(75.0, a3.type_token_ratio(tlist))

    # Testing wiki from sample_lists.py
    tlist = sl.wiki
    ca.assert_floats_equal(23.750000000000004, a3.type_token_ratio(tlist))

    # Testing simplewiki from sample_lists.py
    tlist = sl.simplewiki
    ca.assert_floats_equal(26.249999999999996, a3.type_token_ratio(tlist))

    # Testing dickens from sample_lists.py
    tlist = sl.dickens
    ca.assert_floats_equal(60.0, a3.type_token_ratio(tlist))

    # Testing seuss from sample_lists.py
    tlist = sl.seuss
    ca.assert_floats_equal(50.0, a3.type_token_ratio(tlist))

    # Testing stein from sample_lists.py
    tlist = sl.stein
    ca.assert_floats_equal(50.0, a3.type_token_ratio(tlist))

    # Testing whitehead from sample_lists.py
    tlist = sl.whitehead
    ca.assert_floats_equal(27.500000000000004, a3.type_token_ratio(tlist))

    print_testing('end')    


def test_percent_avg_or_shorter():
    print_testing('start')    

    # given example
    tokenlist = ["a", "b", "ccccc", "dd"]
    tokenlistlist = [ ["abcd", "abcd", "abcd"], tokenlist, ["ef"]]
    ca.assert_floats_equal(75.0, 
                            a3.percent_avg_or_shorter(tokenlist,tokenlistlist))

    #tokenlistlist has only tokenlist
    tokenlist = ["a", "b", "ccccc", "dd"]
    tokenlistlist = [tokenlist]
    ca.assert_floats_equal(75.0, 
                            a3.percent_avg_or_shorter(tokenlist,tokenlistlist))

    literary = [sl.dickens, sl.seuss, sl.stein, sl.whitehead]
    ca.assert_floats_equal(71.25, 
                            a3.percent_avg_or_shorter(sl.dickens,literary))
    ca.assert_floats_equal(88.75, 
                        a3.percent_avg_or_shorter(sl.seuss,literary))
    ca.assert_floats_equal(43.75, 
                        a3.percent_avg_or_shorter(sl.stein,literary))
    ca.assert_floats_equal(65.0, 
                        a3.percent_avg_or_shorter(sl.whitehead,literary))

    print_testing('end')    



def test_zipf():
    print_testing('start')

    print("Testing examples from spec")
    tlist = ["a", "a", "a", "a", "b",  "b",  "b", "c", "c", "d"]
    ca.assert_floats_equal(40.0, a3.zipf(tlist,1))
    ca.assert_floats_equal(70.0, a3.zipf(tlist,2))
    ca.assert_floats_equal(90.0, a3.zipf(tlist,3))
    ca.assert_floats_equal(100.0, a3.zipf(tlist,4))

    tlist = ["a", "a", "b", "b"]
    ca.assert_floats_equal(50.0, a3.zipf(tlist,1))
    ca.assert_floats_equal(100.0, a3.zipf(tlist,2))

    print("Testing examples from sample_lists.py")
    # Testing no_repeats from sample_lists.py
    tlist = sl.no_repeats
    ca.assert_floats_equal(25.0, a3.zipf(tlist,1))
    ca.assert_floats_equal(50.0, a3.zipf(tlist,2))
    ca.assert_floats_equal(75.0, a3.zipf(tlist,3))

    # Testing one_repeat from sample_lists.py
    tlist = sl.one_repeat
    ca.assert_floats_equal(50.0, a3.zipf(tlist,1))
    ca.assert_floats_equal(75.0, a3.zipf(tlist,2))

    # Testing repeats from sample_lists.py
    tlist = sl.repeats
    ca.assert_floats_equal(25.0, a3.zipf(tlist,1))
    ca.assert_floats_equal(46.42857142857143, a3.zipf(tlist,2))
    ca.assert_floats_equal(64.28571428571429, a3.zipf(tlist,3))
    ca.assert_floats_equal(78.57142857142857, a3.zipf(tlist,4))
    ca.assert_floats_equal(89.28571428571429, a3.zipf(tlist,5))
    ca.assert_floats_equal(96.42857142857143, a3.zipf(tlist,6))

    # Testing wiki from sample_lists.py
    tlist = sl.wiki
    ca.assert_floats_equal(5.0, a3.zipf(tlist,1))
    ca.assert_floats_equal(8.75, a3.zipf(tlist,2))
    ca.assert_floats_equal(12.5, a3.zipf(tlist,3))
    ca.assert_floats_equal(16.25, a3.zipf(tlist,4))
    ca.assert_floats_equal(20.0, a3.zipf(tlist,5))
    ca.assert_floats_equal(23.75, a3.zipf(tlist,6))
    ca.assert_floats_equal(26.25, a3.zipf(tlist,7))
    ca.assert_floats_equal(28.75, a3.zipf(tlist,8))
    ca.assert_floats_equal(31.25, a3.zipf(tlist,9))
    ca.assert_floats_equal(33.75, a3.zipf(tlist,10))

    # Testing simplewiki from sample_lists.py
    tlist = sl.simplewiki
    ca.assert_floats_equal(6.25, a3.zipf(tlist,1))
    ca.assert_floats_equal(10.0, a3.zipf(tlist,2))
    ca.assert_floats_equal(13.75, a3.zipf(tlist,3))
    ca.assert_floats_equal(17.5, a3.zipf(tlist,4))
    ca.assert_floats_equal(20.0, a3.zipf(tlist,5))
    ca.assert_floats_equal(22.5, a3.zipf(tlist,6))
    ca.assert_floats_equal(25.0, a3.zipf(tlist,7))
    ca.assert_floats_equal(27.5, a3.zipf(tlist,8))
    ca.assert_floats_equal(30.0, a3.zipf(tlist,9))
    ca.assert_floats_equal(32.5, a3.zipf(tlist,10))

    # Testing dickens from sample_lists.py
    tlist = sl.dickens
    ca.assert_floats_equal(12.5, a3.zipf(tlist,1))
    ca.assert_floats_equal(25.0, a3.zipf(tlist,2))
    ca.assert_floats_equal(37.5, a3.zipf(tlist,3))
    ca.assert_floats_equal(50.0, a3.zipf(tlist,4))
    ca.assert_floats_equal(55.0, a3.zipf(tlist,5))
    ca.assert_floats_equal(57.5, a3.zipf(tlist,6))
    ca.assert_floats_equal(60.0, a3.zipf(tlist,7))
    ca.assert_floats_equal(62.5, a3.zipf(tlist,8))
    ca.assert_floats_equal(65.0, a3.zipf(tlist,9))
    ca.assert_floats_equal(67.5, a3.zipf(tlist,10))

    # Testing seuss from sample_lists.py
    tlist = sl.seuss
    ca.assert_floats_equal(10.0, a3.zipf(tlist,1))
    ca.assert_floats_equal(16.25, a3.zipf(tlist,2))
    ca.assert_floats_equal(21.25, a3.zipf(tlist,3))
    ca.assert_floats_equal(26.25, a3.zipf(tlist,4))
    ca.assert_floats_equal(30.0, a3.zipf(tlist,5))
    ca.assert_floats_equal(33.75, a3.zipf(tlist,6))
    ca.assert_floats_equal(37.5, a3.zipf(tlist,7))
    ca.assert_floats_equal(41.25, a3.zipf(tlist,8))
    ca.assert_floats_equal(45.0, a3.zipf(tlist,9))
    ca.assert_floats_equal(48.75, a3.zipf(tlist,10))

    # Testing stein from sample_lists.py
    tlist = sl.stein
    ca.assert_floats_equal(7.5, a3.zipf(tlist,1))
    ca.assert_floats_equal(12.5, a3.zipf(tlist,2))
    ca.assert_floats_equal(17.5, a3.zipf(tlist,3))
    ca.assert_floats_equal(22.5, a3.zipf(tlist,4))
    ca.assert_floats_equal(27.5, a3.zipf(tlist,5))
    ca.assert_floats_equal(32.5, a3.zipf(tlist,6))
    ca.assert_floats_equal(37.5, a3.zipf(tlist,7))
    ca.assert_floats_equal(41.25, a3.zipf(tlist,8))
    ca.assert_floats_equal(45.0, a3.zipf(tlist,9))
    ca.assert_floats_equal(48.75, a3.zipf(tlist,10))

    # Testing whitehead from sample_lists.py
    tlist = sl.whitehead
    ca.assert_floats_equal(6.25, a3.zipf(tlist,1))
    ca.assert_floats_equal(11.25, a3.zipf(tlist,2))
    ca.assert_floats_equal(15.0, a3.zipf(tlist,3))
    ca.assert_floats_equal(18.75, a3.zipf(tlist,4))
    ca.assert_floats_equal(22.5, a3.zipf(tlist,5))
    ca.assert_floats_equal(25.0, a3.zipf(tlist,6))
    ca.assert_floats_equal(27.5, a3.zipf(tlist,7))
    ca.assert_floats_equal(30.0, a3.zipf(tlist,8))
    ca.assert_floats_equal(32.5, a3.zipf(tlist,9))
    ca.assert_floats_equal(35.0, a3.zipf(tlist,10))

    print_testing('end')


if __name__ == '__main__':

    test_percent_short()
    test_print_trend()
    test_type_token_ratio()
    test_percent_avg_or_shorter()
    test_zipf()









