# sample_lists.py
# Mar 9, 2022
# Prof. Lee, LJL2

"""Create some tokenlists for students to use for testing"""

import string # for removing punctuation

# List of tokenlists. sample_labels is the names of the variables for each list.
# Will be built up incrementally.
sample_tokenlists = []
sample_labels = []



# max length of passage for samples
MAX_LENGTH=80

def listit(s):
    """lowercase, strip punctuation except apostrophes and hyphens, 
    strip numbers, return a list of tokens in s"""
    # we will preserve apostrophes and hyphens, but delete other punctuation
    delete_chars = string.punctuation.replace("'", '').replace('-','')
    delete_chars += string.digits
    deletemap=''.maketrans(delete_chars, " "*len(delete_chars))

    return s.lower().translate(deletemap).split()[:MAX_LENGTH]

no_repeats = listit('a b c d')
sample_tokenlists.append(no_repeats)
sample_labels.append("no_repeats")

one_repeat = listit("a b b c")
sample_tokenlists.append(one_repeat)
sample_labels.append("one_repeat")  

repeats = listit('''apple banana carrot dog elephant food garage
apple banana carrot dog elephant food
apple banana carrot dog elephant
apple banana carrot dog
apple banana carrot
apple banana
apple''')
sample_tokenlists.append(repeats)
sample_labels.append("repeats")

wiki = listit('''
Python is a high-level, general-purpose programming language. Its design philosophy emphasizes code readability with the use of significant indentation. Its language constructs and object-oriented approach aim to help programmers write clear, logical code for small- and large-scale projects.[29]

Python is dynamically-typed and garbage-collected. It supports multiple programming paradigms, including structured (particularly procedural), object-oriented and functional programming. It is often described as a "batteries included" language due to its comprehensive standard library.[30][31]

Guido van Rossum began working on Python in the late 1980s as a successor to the ABC programming language and first released it in 1991 as Python 0.9.0.[32] Python 2.0 was released in 2000 and introduced new features such as list comprehensions, cycle-detecting garbage collection, reference counting, and Unicode support. Python 3.0, released in 2008, was a major revision that is not completely backward-compatible with earlier versions. Python 2 was discontinued with version 2.7.18 in 2020.[33]

Python consistently ranks as one of the most popular programming languages.[34][35][36][37]
''')
sample_tokenlists.append(wiki)
sample_labels.append("wiki")

simplewiki = listit('''
Python is an open source programming language. It was made to be easy-to-read and powerful. A Dutch programmer named Guido van Rossum made Python in 1991. He named it after the television program Monty Python's Flying Circus. Many Python examples and tutorials include jokes from the show.[30]

Python is an interpreted language. Interpreted languages do not need to be compiled to run. A program called an interpreter runs Python code on almost any kind of computer. This means that a programmer can change the code and quickly see the results. This also means Python is slower than a compiled language like C, because it is not running machine code directly.

Python is a good programming language for beginners. It is a high-level language, which means a programmer can focus on what to do instead of how to do it. Writing programs in Python takes less time than in some other languages.

Python drew inspiration from other programming languages like C, C++, Java, Perl, and Lisp.

Python's developers try to avoid changing the language to make it better until they have a lot of things to change. Also, they try not to make small repairs, called patches, to unimportant parts of the CPython reference implementation that would make it faster. When speed is important, a Python programmer can move some of the work of the program to other parts written in programming languages like C or PyPy, a just-in-time compiler. It translates a Python script into C and makes direct C-level API calls into the Python interpreter.

Keeping Python fun to use is an important goal of Python’s developers. It reflects in the language's name, a tribute to the British comedy group Monty Python. On occasions, there are playful approaches to tutorials and reference materials, such as referring to spam and eggs instead of the standard foo and bar.
''')
sample_tokenlists.append(simplewiki)
sample_labels.append("simplewiki")



dickens = listit(''' It was the best of times, it was the worst of times, it
was the age of wisdom, it was the age of foolishness, it was the epoch of
belief, it was the epoch of incredulity, it was the season of Light, it was
the season of Darkness, it was the spring of hope, it was the winter of
despair, we had everything before us, we had nothing before us, we were all
going direct to Heaven, we were all going direct the other way--in short, the
period was so far like the present period that some of its noisiest
authorities insisted on its being received, for good or for evil, in the
superlative degree of comparison only.
''')
sample_tokenlists.append(dickens)
sample_labels.append("dickens")

seuss=listit('''
the sun did not shine.
it was too wet to play.
so we sat in the house
all that cold, cold, wet day.

i sat there with sally.
we sat there, we two.
and i said, 'how i wish
we had something to do!'

too wet to go out
and too cold to play ball.
so we sat in the house.
we did nothing at all.

so all we could do was to
sit!
sit!
sit!
sit!
and we did not like it.
not one little bit.

and then something went BUMP!
how that bump made us jump!
we looked!
then we saw him step in on the mat!
we looked!
and we saw him!
the cat in the hat!
and he said to us,
'why do you sit there like that?'
'i know it is wet
and the sun is not sunny.
but we can have
lots of good fun that is funny!'

'i know some good games we could play,'
said the cat.
'i know some new tricks,'
said the cat in the hat.
'a lot of good tricks.
i will show them to you.
your mother will not mind at all if i do.'

''')
sample_tokenlists.append(seuss)
sample_labels.append("seuss")



stein = listit('''
    Argonauts.
    That is plenty.
    Cunning saxon symbol.
    Symbol of beauty.
    Thimble of everything.
    Cunning clover thimble.
    Cunning of everything.
    Cunning of thimble.
    Cunning cunning.
    Place in pets.
    Night town.
    Night town a glass.
    Color mahogany.
    Color mahogany center.
    Rose is a rose is a rose is a rose.
    Loveliness extreme.
    Extra gaiters.
    Loveliness extreme.
    Sweetest ice-cream.
    Page ages page ages page ages.
    Wiped Wiped wire wire.
    Sweeter than peaches and pears and cream.
    Wiped wire wiped wire
    Extra extreme.
    Put measure treasure.
    Measure treasure.
    Tables track.
    Nursed.
    Dough.
    That will do.
    Cup or cup or.
    Excessively illigitimate.
    Pussy pussy pussy what what.
    Current secret sneezers.
    Ever.
    Mercy for a dog.
    Medal make medal.
    Able able able.
''')
sample_tokenlists.append(stein)
sample_labels.append("stein")


whitehead = listit('''I have a good poker face because I am half dead inside.
    My particular combo of slack features, negligible affect, and soulless
    gaze has helped my game ever since I started playing twenty years ago,
    when I was ignorant of pot odds and M-theory and four-betting, and it 
    gave me a boost as I collected my trove of lore, game by game, hand by
    hand.  It has not helped me human relationships-wise over the years, but 
    surely I'm not alone here.  Anyone whose peculiar mix of genetic material
    and formative experiences has resulted in a near-expressionless mask can
    relate.  Nature giveth, taketh, etc. You make the best of the hand you're
    dealt.

''')
sample_tokenlists.append(whitehead)
sample_labels.append("whitehead")

# BEGIN REMOVE
if __name__ == '__main__':

    from collections import Counter
    print("% from running solution/sample_lists.py")

    for i in range(len(sample_tokenlists)):
        print("\\ltname{" + sample_labels[i].replace("_", "\\_") + "}")
        lt = sample_tokenlists[i]
        print(lt)
        c = Counter(lt)
        print("\\par Number of tokens: " + str(len(lt)))
        print("\\stats")
        print(str(c)[9:-2])
        # print(c.most_common(10))
        print("\n\\smallskip")

# END REMOVE
